<?php
/* 
 * Copie des fichiers ncessaires aux fonctionnalits du module 
 * @module newsletteradmin 
 * @copyright eolia@o2switch.net
*/

include(dirname(__FILE__).'/../../config/config.inc.php');
include(dirname(__FILE__).'/functions.php');

$filename = 'INSTALL';

if(intval(Configuration::get('PS_REWRITING_SETTINGS')) === 1)
	$rewrited_url = __PS_BASE_URI__;

	Configuration::updateValue('Admin_Newsletter_Version', '2.2');
	$iso = Configuration::get('PS_LOCALE_LANGUAGE'); 
	$rep_lang = _PS_MODULE_DIR_.'newsletteradmin/lang';
	$files = 'scripts';
	$trans_lang = $rep_lang.'/lang_'.$iso.'.php';
	$uni_lang = $rep_lang.'/uni_lang.php';
	$temp_lang = $rep_lang.'temp.php';
			if ($iso != 'en') {
				if (!file_exists ($trans_lang)){
				if (file_exists($uni_lang)) {
				copy($uni_lang,$temp_lang); 
				rename($temp_lang,$trans_lang);
			echo '<b>'.trans('A translation file for your language has been created here').':</b> '.$trans_lang.'<br/>'.trans('You can edit it later to translate the expressions in your language').'.';}
			else die('<font color="red">Error: The files uni_lang.php is missing! <br/><br/>Verify your archive in '.$rep_lang.'</font>');
		}
				else{ echo '<b>'.trans('A translation file for your language is here').':</b> '.$trans_lang.'<br/>';}
			}else{ echo 'No translations required to your language (English)';}
			
    function smartCopy($source, $dest, $options=array('folderPermission'=>0755,'filePermission'=>0755)) 
    { 
        $result=false; 
        
        if (is_file($source)) { 
		echo trans('Copying file').': ';		
            if ($dest[strlen($dest)-1]=='/') { 
                if (!file_exists($dest)) { 
                    cmfcDirectory::makeAll($dest,$options['folderPermission'],true); 
                } 
                $__dest=$dest."/".basename($source); 
            } else { 
                $__dest=$dest;
		echo $__dest.'...<br/>';				
            } 
            $result=copy($source, $__dest); 
            chmod($__dest,$options['filePermission']); 
        
        } elseif(is_dir($source)) { 
            if ($dest[strlen($dest)-1]=='/') { 
                if ($source[strlen($source)-1]=='/') { 
                    //Copy only contents 
                } else { 
                    //Change parent itself and its contents 
                    $dest=$dest.basename($source); 
                    @mkdir($dest); 
                    chmod($dest,$options['filePermission']); 
                } 
            } else { 
                if ($source[strlen($source)-1]=='/') { 
                    //Copy parent directory with new name and all its content 
                    @mkdir($dest,$options['folderPermission']); 
                    chmod($dest,$options['filePermission']); 
                } else { 
                    //Copy parent directory with new name and all its content 
                    @mkdir($dest,$options['folderPermission']); 
                    chmod($dest,$options['filePermission']); 
                } 
            } 

            $dirHandle=opendir($source); 
            while($file=readdir($dirHandle)) 
            { 
                if($file!="." && $file!="..") 
                { 
                     if(!is_dir($source."/".$file)) { 
                        $__dest=$dest."/".$file; 
                    } else { 
                        $__dest=$dest."/".$file; 
                    } 
                    $result=smartCopy($source."/".$file, $__dest, $options); 
                } 
            } 
            closedir($dirHandle);            
        } else {$result=false; 
        } 
        return $result; 
    }
	
	
		echo '
		<form action="'.$_SERVER['REQUEST_URI'].'" method="post">
		<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
		<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
		<head>
        <meta http-equiv="content-type" content="text/html; charset=iso-8859-1" />
        <title>'.trans('Update Files').'</title>
			<fieldset style="background:#FFFFF0;border:1px solid #DFD5C3;font-size:1em;margin:50px;padding:1em">
				<legend><img src="logo.gif"  alt="" title="Newsletter" /> <a style="margin: 0;padding: 0.2em 0.5em;border: 1px solid #DFD5C3;background: #FFF6D3;font-weight: bold;text-align: left;">'.trans('Copying files to your server').' </a></legend>
				<label><b>'.trans('Copying files').'...</b><br/></label>';
	

		$adir = Configuration::get('ADMIN_DIR');
		$files = 'AdminNewsletter.php';
		$file_bak= 'AdminNewsletter.php.bak';
		$iso = Configuration::get('PS_LOCALE_LANGUAGE');


		if (!file_exists($files)) @rename($file_bak,$files) or die('<font color="red">'.trans('Error: The files AdminNewsletter.php or AdminNewsletter.php.bak not exist! Verify your archive').'</font>');
		if (file_exists($files)){
			$files2 = $adir.'/tabs/AdminNewsletter.php';
			if (smartCopy($files, $files2, $options=array('folderPermission'=>0755,'filePermission'=>0755)))
			{
			echo '<b><p align="center">'.trans('Finish!').'</p><br/>'.trans('The file').' '.$files.' '.trans('was successfully copied to').' '.$files2.'</b><br/><br/>'; 
			rename($files,$file_bak);
			}
		else echo '<b>'.trans('Error!').' '.trans('Please check your chmod rights').'</b><br/><br/>'; 				
		}				
						//Check if ps version is < to 1.4
			$psVersion = _PS_VERSION_;
			if ( strlen($psVersion) == '5')
			$psVersion = str_replace($psVersion,$psVersion.'.0', $psVersion);//missed in some versions
			$subVersions = str_replace('.','', $psVersion);		
			if ($subVersions < 1400){
			$tiny = '/tinymce/jscripts/';			
			}else {
			$tiny = '/';
			}
			
		$files = 'tiny_mce';
		$files2 =  _PS_ROOT_DIR_.'/js'.$tiny;
		$dest = '/js'.$tiny;
		if (!is_dir($files)) echo '<font color="red">'. trans('Error: The directory').' '. $files.' '.trans('not exist! Verify your archive').'</font><br/>';
			if (smartCopy($files, $files2, $options=array('folderPermission'=>0755,'filePermission'=>0755))){
			$template =  _PS_ROOT_DIR_.'/js'.$tiny.'tiny_mce/lists/template_list.php';
			$template2 = _PS_ROOT_DIR_.'/js'.$tiny.'tiny_mce/lists/template_list2.php';
			$template1 = _PS_ROOT_DIR_.'/js'.$tiny.'tiny_mce/lists/template_list1.php';		
			if ($subVersions < 1400){		
			rename($template2,$template);
			echo trans('Renaming the file').' template_list1.php -> template_list.php...<br/>';
			unlink($template1);
			}else {
			rename($template1,$template);
			echo trans('Renaming the file').' template_list2.php -> template_list.php...<br/>';
			unlink($template2);
			}
			echo '<b><p align="center">'.trans('Finish!').'</p><br/>'.trans('The entire file').' '.$files.' '.trans('was successfully copied to').' '.$files2.'</b><br/><br/>'; 
			}else echo '<b>'.trans('Error!').' '.trans('The entire file').' '.$files.' '.trans('could not be copied to').' '.$files2.'</b><br/><br/>';
			
				
			
		$files = 'scripts/files';
		$files2 =  _PS_ROOT_DIR_;
		if (!is_dir($files)) echo '<font color="red">'. trans('Error: The directory').' '. $files.' '.trans('not exist! Verify your archive').'</font><br/>';
			if (smartCopy($files, $files2, $options=array('folderPermission'=>0755,'filePermission'=>0755))){
			echo '<b><p align="center">'.trans('Finish!').'</p><br/>'.trans('The entire file').' '.$files.' '.trans('was successfully copied to').' '.$files2.'</b><br/><br/>'; 
			}else echo '<b>'.trans('Error!').' '.trans('The entire file').' '.$files.' '.trans('could not be copied to').' '.$files2.'</b><br/><br/>'; 
		$files = 'scripts/manage';
		$files2 =  _PS_ROOT_DIR_;
		if (!is_dir($files)) echo '<font color="red">'. trans('Error: The directory').' '. $files.' '.trans('not exist! Verify your archive').'</font><br/>';
			if (smartCopy($files, $files2, $options=array('folderPermission'=>0755,'filePermission'=>0755))){
			echo '<b><p align="center">'.trans('Finish!').'</p><br/>'.trans('The entire file').' '.$files.' '.trans('was successfully copied to').' '.$files2.'</b><br/><br/>'; 
			}else echo '<b>'.trans('Error!').' '.trans('The entire file').' '.$files.' '.trans('could not be copied to').' '.$files2.'</b><br/><br/>'; 			
		$files = 'modules';
		$files2 =  _PS_ROOT_DIR_.'/modules';
		if (!is_dir($files)) echo '<font color="red">'. trans('Error: The directory').' '. $files.' '.trans('not exist! Verify your archive').'</font><br/>';
			if (smartCopy($files, $files2, $options=array('folderPermission'=>0755,'filePermission'=>0755))){
			echo '<b><p align="center">'.trans('Finish!').'</p><br/>'.trans('The entire file').' '.$files.' '.trans('was successfully copied to').' '.$files2.'</b><br/><br/>'; 
			}else echo '<b>'.trans('Error!').' '.trans('The entire file').' '.$files.' '.trans('could not be copied to').' '.$files2.'</b><br/><br/>'; 
		echo  '
			</fieldset>';
			
	if (file_exists ('translate_admin_'.$iso.'.txt')){
		echo  '
		<fieldset style="background:#FFFFF0;border:1px solid #DFD5C3;font-size:1em;margin:50px;padding:1em">
		<legend><img src="logo.gif"  alt="" title="Newsletter" /> <a style="margin: 0;padding: 0.2em 0.5em;border: 1px solid #DFD5C3;background: #FFF6D3;font-weight: bold;text-align: left;">'.trans('To copy in your file').' "/translations/'.$iso.'./admin.php" </a></legend>
		<label><b>'.trans('Add it at the bottom of the file, before ?> or use the traditional method of translation').'></b><br/></label>	
		'; 
		
	$read=fopen('translate_admin_'.$iso.'.txt','r'); 
	if ($read){
		while (!feof ($read))
		{
		$tampon = fgets($read, 4096);
		echo '<br>'.$tampon;
		}
	fclose($read);	
			}
	}
		if (isset($_SERVER['HTTP_REFERER'])) {

			echo'
			<a href="'.$_SERVER['HTTP_REFERER'].'">
				<center><button> '.trans('Back').'</button></a></center>';
				}
			else{
			echo '<center><input type="button" class="button" value="'.trans('Back').'" onClick="javascript:history.go(-1)" />';}
	echo '		</fieldset>
				</form>';

?>