<?php
/*
 * Regroupement de certaines fonctions communes 
 * @module newsletteradmin 
 * @copyright eolia@o2switch.net
*/

	function trans($string)
	{
		$iso = Configuration::get('PS_LOCALE_LANGUAGE');
		global $filename;
		$trans_lang = _PS_MODULE_DIR_.'newsletteradmin/lang/lang_'.$iso.'.php';
		
		if ($iso == 'en') return $string;
		if(file_exists ($trans_lang)) {
			include $trans_lang;

			if (isset ($_LANG[$filename.' '.$string])) {
				return html_entity_decode ($_LANG[$filename.' '.$string]);}

			else 
			{
					$wadd=fopen($trans_lang, 'a+');
					$r = chr(13); 
					str_replace('?>','',$wadd);
					fwrite($wadd,'$_LANG[\''.$filename.' '. $string.'\'] = \''.$string.'\';'.$r);
					fclose($wadd);
					
			return $string;
			}
		}
		else {
		echo 'Warning, Your translation file not exists! Please re-configure your module';
			return $string;}
		
	}

	function nlog($log_message)
		{
		$date = date("d-m-Y");
		$time = date("H\h i\m s\s");
		$log = '../modules/newsletteradmin/logs/'.$date.'.txt' ;
		$wlog=fopen($log, 'a+');
		$log_message = str_replace("&#039;","'", $log_message);
		fwrite($wlog,$log_message);
		$r = chr(13); 	
		//fwrite($wlog,$r);	
		fclose($wlog);
		}

	function cmp($a,$b) 
		{
		if ($a[1] == $b[1])
			return 0;
		return ($a[1] < $b[1]) ? 1 : -1 ;
		}

	
	function rotate_logs()
		{
			$repertoire_sauvegardes = '../modules/newsletteradmin/logs/';			
			if ($repertoire_ouvert = opendir($repertoire_sauvegardes)) 
			{
				while($fichier_en_cours = readdir($repertoire_ouvert)) {       
						if(is_file($repertoire_sauvegardes.$fichier_en_cours)) {
						$tableau_sauvegardes[] = array($fichier_en_cours, filectime($repertoire_sauvegardes.$fichier_en_cours)) ;
						}
					}
					closedir($repertoire_ouvert) ;  
				}

				$numero_fichier = null;
				usort($tableau_sauvegardes, 'cmp') ;
				// Lecture des entres tries par date
				foreach($tableau_sauvegardes as $element) {

					if( $numero_fichier > 10 ) {
						// Suppression des sauvegardes obsoltes
						unlink($repertoire_sauvegardes.$element[0]) ;
					}
					$numero_fichier++ ;
				}	
		}